@echo off
cls
rem   # Script desenvolvido pela Equipe da REDEMET para Consulta Automatica de Mensagens, utilizando a API da REDEMET
rem   #
rem   # Trata-se apenas de um exemplo de como pode ser utilizada a API da REDEMET
rem   # para consultas de mensagens meteorologicas para periodos maiores que 24 horas.
rem   #
rem   # Utilize os recursos de forma consciente, solicitando apenas as informacoes necessarias para que possamos atender a maior
rem   # quantidade de usuarios com a melhor qualidade possivel.
rem   #
rem   #
rem   #################################################################################################################################
rem   # Inicio da Personalizacao do Usuario
rem   #################################################################################################################################
rem   # Parametros da API de consulta de mensagens
rem   # ESTES PARAMETROS, DEVEM SER PREENCHIDOS DE ACORDO COM AS INSTRUCOES PARA A UTILIZACAO DA API, CONTIDAS NO
rem   # ENDERECO: http://www.redemet.aer.mil.br/api/consulta_automatica/ ou
rem   # http://www.redemet.intraer/api/consulta_automatica/

rem # Define se sera acrescentado no inicio da linha o grupo data/hora da mensagem
set exibir_data_hora=sim

rem # Define se sera acrescentado o cabecalho ICAO  da mensagem
set exibir_cabecalho=nao

rem # Define o tipo(s) de mensagem(ns) que sera(ao) solicitado(s)
set tipos_de_mensagem=metar

rem # Define as localidades/fir/numeros sinoticos para os quais as mensagens serao consultadas ( Maximo de 10 )
set localidades_ou_sinoticos=sbpa,sbct,sbgr,sbgl,sbvt,sbbh,sbbr,sbnt,sbbe,sbmn

rem #
rem # Parametros do SCRIPT
rem # Arquivo texto onde sera gravado o resultado final da consulta
set arquivo_resultado=metar.txt

rem # Data/Hora do inicio da consulta. Formato YYYYmmdd
set data_inicio=20150227

rem # Quantidade de dias desejados para a Consulta. A partir da data_hora_inicio, o script buscara mensagens para a quantidade de dias
rem # especificados na variavel abaixo
set dias_da_consulta=10

rem # Define se a consulta sera feira por meio da internet ou da intraer (Rede interna da Aeronautica)
rem # Sao aceitas as opcoes internet ou intraer
set meio_consulta=internet

rem #################################################################################################################################
rem # Fim da Personalizacao do Usuario
rem #################################################################################################################################


rem ###################################################################################################################################
rem # A T E N C A O   A T E N C A O   A T E N C A O    A T E N C A O    A T E N C A O    A T E N C A O   A T E N C A O  A T E N C A O #
rem #       Caso os parametros abaixo sejam alterados, o script pode deixar de funcionar corretamente                     #
rem #   Apenas as alteracoes nos campos acima ja sao suficientes para a consulta de todos os tipos de mensagem para qualquer periodo #
rem ###################################################################################################################################

rem # Configuracoes do Servidor

if  %meio_consulta%==intraer set nome_servidor=www.redemet.intraer
if  %meio_consulta%==internet set nome_servidor=www.redemet.aer.mil.br
if  %meio_consulta%=="" set nome_servidor=www.redemet.aer.mil.br

rem # Define o nome do executavel do WGET
set wget=wget.exe

set user_agent=--user-agent="Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)"
set base_url=--base=http://%nome_servidor%/api/consulta_automatica/index.php
set referer=--referer=http://%nome_servidor%/api/consulta_automatica/index.php
set url_consulta=http://%nome_servidor%/api/consulta_automatica/index.php

rem # Apaga o arquivo do Resultado Final
del %arquivo_resultado%

rem # Apaga o arquivo do Resultado temporario
del resultado.tmp

set contador_dia=1
set loopcount=%dias_da_consulta%
:loop

set ano_ini=%data_inicio:~0,4%
set mes_ini=%data_inicio:~4,2%
set dia_ini=%data_inicio:~6,2%

set data_hora_inicio=%ano_ini%%mes_ini%%dia_ini%00
set data_hora_fim=%ano_ini%%mes_ini%%dia_ini%23

set comando=%wget% %user_agent% %base_url% %referer% --post-data="&local=%localidades_ou_sinoticos%&msg=%tipos_de_mensagem%&data_ini=%data_hora_inicio%&data_fim=%data_hora_fim%&data_hora=%exibir_data_hora%&cabecalho=%exibir_cabecalho%" -O resultado.tmp %url_consulta%

%comando%

type resultado.tmp >>   %arquivo_resultado%

rem # Executa a funcao para calcular o dia seguinte
call:calculaDataFim

set ano_fim=%data_fim:~0,4%
set mes_fim=%data_fim:~4,2%
set dia_fim=%data_fim:~6,2%

set data_inicio=%data_fim%

set /a loopcount=loopcount-1
if %loopcount%==0 goto exitloop
goto loop
:exitloop
del resultado.tmp
echo "Fim da Execucao do Programa"

:calculaDataFim -- funo para calcular o proximo dia
:$created 02/11/2011 :Sauthor Pedro Elsner - Alterado por Fernando Reis  (19/10/2015)

@echo off &SETLOCAL
SET "data_inicial=%dia_ini%/%mes_ini%/%ano_ini%"
CALL:DateToJDN %data_inicial% data_inicial_numero
SET /a data_fim_numero=data_inicial_numero+1
CALL:JDNToDate %data_fim_numero% data_fim
endlocal & set data_fim=%data_fim%
exit /b 0
GOTO:EOF

rem Convert the date to Julian Day Number
:DateToJDN dd.mm.yyyy jdn=
setlocal
set date=%1
set /A yy=%date:~-4%, mm=1%date:~-7,2% %% 100, dd=1%date:~-10,2% %% 100
set /A a=mm-14, jdn=(1461*(yy+4800+a/12))/4+(367*(mm-2-12*(a/12)))/12-(3*((yy+4900+a/12)/100))/4+dd-32075
endlocal & set %2=%jdn%
exit /B

rem Convert Julian Day Number back to date

:JDNToDate jdn dd.mm.yyyy=
setlocal
set /A l=%1+68569,n=(4*l)/146097,l=l-(146097*n+3)/4,i=(4000*(l+1))/1461001,l=l-(1461*i)/4+31,j=(80*l)/2447,dd=l-(2447*j)/80,l=j/11,mm=j+2-(12*l),yy=100*(n-49)+i+l
if %dd% lss 10 set dd=0%dd%
if %mm% lss 10 set mm=0%mm%
rem endlocal & set %2=%dd%.%mm%.%yy%
endlocal & set %2=%yy%%mm%%dd%
exit /b 0
endlocal